routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Route::group(['prefix' => 'admin', 'namespace' => 'Admin','as'=>'admin.'], function () {
    Route::get('/', 'AdminController@index')->name('index');
    Route::group(['prefix' => 'category','as'=>'category.'], function () {
        Route::get('/', 'CategoryController@index')->name('list');
        Route::get('/add', 'CategoryController@create')->name('add');
        Route::post('/created', 'CategoryController@store')->name('created');
        Route::get('edit/{id}', 'CategoryController@edit')->name('edit');
        Route::put('/{id}', 'CategoryController@update')->name('update');
        Route::delete('/category/{id}', 'CategoryController@destroy')->name('destroy');
    });
    Route::group(['prefix' => 'product','as'=>'product.'], function () {
        Route::get('/', 'ProductController@index')->name('list');
        Route::get('/add', 'ProductController@create')->name('add');
        Route::post('/created', 'ProductController@store')->name('created');
        Route::get('edit/{id}', 'ProductController@edit')->name('edit');
        Route::post('/{id}', 'ProductController@update')->name('update');
        Route::delete('/product/{id}', 'ProductController@destroy')->name('destroy');
         Route::post('uploadimage/{type?}', 'ProductController@uploadImage')->name('uploadimage');
           Route::post('/deleteimage', 'ProductController@deleteImage')->name('deleteimage');
    });
});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    protected $fillable=['name','slug','status'];

    public function parent()
    {
    	return $this->belongsTo('App\Models\Category','parent_id');
    }

     public function children()
    {
    	return $this->hasMany('App\Models\Category','parent_id');
    }
      public function product()
    {
    	return $this->hasMany(App\Models\Product::class);
    }
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Category;
use Illuminate\Http\Request;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = Category::select()->paginate(5);
        return view('AdminPage.category.list',
            [
                'categories' => $categories
            ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('AdminPage.category.createOrUpdate');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $categories = Category::findOrFail($id);
        $categories->delete();
        return redirect()->route('admin.category.list');
    }
}

resources/views/AdminPage/category/createOrUpdate.blade.php
@extends('AdminPage.layouts.master')
@section('content')
@endsection

resources/views/AdminPage/category/list.blade.php
@extends('Adminpage.layouts.master')
@section('content')
<div class="row">
	<div class="col-md-12">

		<div class="card ">
			<div class="card-header">
				<h4 class="card-title"> Category Table</h4>
			</div>
			<div class="row">
			<div class="col-md-6">
				<a class="btn btn-success text-center" href="{{route('admin.category.add')}}" style="width: 100%;margin-bottom: 10px;">
				Add </a>
			</div>         
		</div>
			<div class="card-body">
				<div class="table-responsive">
					<table class="table tablesorter " id="">
						<thead class=" text-primary">
							<tr>
								<th>
									ID
								</th>
								<th>
									Name
								</th>
								<th>
									Status
								</th>
								<th class="text-center">
									Parent ID
								</th>
								<th class="text-center">
									Parent Name
								</th>
							</tr>
						</thead>
						<tbody>
						@if($categories)
							@foreach($categories as $category)
								<tr>
									<td>
										{{$category->id}}
									</td>
									<td>
										{{$category->name}}
									</td>
									<td>
										{{$category->status}}
									</td>
									<td class="text-center">
										{{$category->parent_id}}
									</td>
									<td class="text-center">
										{{$category->parent->name ?? "Error Or Parent"}}
									</td>
									<td>
										<a class="btn btn-primary" href="{{route('admin.category.edit',['id'=>$category->id])}}">Update</a>
									</td>
									<td>
										<form action="{{route('admin.category.destroy',['id'=>$category->id])}}" method="POST">
										@method('DELETE')
										@csrf
										<button class="btn btn-danger">Delete</button>
										</form>    
									</td>
								</tr>
							@endforeach
						@endif

						</tbody>
					</table>
				</div>
			</div>
			<div class="row" style="margin:0 auto;">
				{{$categories->links()}}
			</div>
		</div>
	</div>
</div>
@endsection